library ieee;
use ieee.std_logic_1164.all,ieee.numeric_std.all;

entity reg_16 is
port
(
	clock:in std_logic;
	write:in std_logic;
	in0:in std_logic_vector(15 downto 0);
	out0:out std_logic_vector(15 downto 0)
);
end reg_16;

architecture reg_16_beh of reg_16 is
signal reg:std_logic_vector(15 downto 0);
begin
	process(clock,write,in0,reg)
	begin
		if(reg="UUUUUUUUUUUUUUUU") then
			reg<="0000000000000000";
		end if;
		if(write='1' and clock='1') then
			reg<=in0 after 4 ns;
		end if;
		out0<=reg;
	end process;
end reg_16_beh;
