library ieee;
use ieee.std_logic_1164.all,ieee.numeric_std.all;

entity mux2to1_16 is
port
(
	sel:in std_logic;
	in0:in std_logic_vector(15 downto 0);
	in1:in std_logic_vector(15 downto 0);
	out0:out std_logic_vector(15 downto 0)
);
end mux2to1_16;

architecture mux2to1_16_beh of mux2to1_16 is
begin
	process(sel,in0,in1)
	begin
		case sel is
			when '0'=>out0<=in0;
			when '1'=>out0<=in1;
			when others=>out0<="0000000000000000";
		end case;
	end process;
end mux2to1_16_beh;
